#!/bin/sh

#java="java -client -Xmx1024m -Xms1024m"
java="java"
#java="java -verbose:gc -Xmx1g -Xms1g -XXaggressive"

warmup=5000
duration=1000

for t in 48; do
#100% writes means 50% successful add/remove and 50% unsuccessful add/remove
#w=100
for w in 50; do

# i will be r/2 as we initially insert half of the items
#for r in 2048 8192 16384 32768 65536 204800; do
for r in 20480; do

for b in OOTBTree BOOTBTree STM CFTree PTBTree; do
:>logs/intset-${b}-i${i}-w${w}-t${t}-r${r}.log
for o in 1 5 10 15 20 25; do

throughput=0
aborts=0

for tr in 1 2 3 4 5; do

echo $b " t= " $t " w= " $w " o= " $o " i= " $i " r= " $r " (Trial number " $tr ")"

log=logs/intset-${b}-i${i}-w${w}-t${t}-r${r}.log

if [ "$b" = "STM" ]; then
	result=$(echo "${java} -javaagent:Deuce/bin/deuceAgent.jar -cp Deuce/bin/deuceTests.jar org.deuce.benchmark.Driver -n ${t} -d ${duration} -w ${warmup} org.deuce.benchmark.intset.Benchmark RBTree -r ${r} -w ${w} -o ${o}")
#elif [ "$b" = "TL2" ]; then
#	result=$(echo "${java} -javaagent:Deuce/bin/deuceAgent.jar -cp Deuce/bin/deuceTests.jar -#Dorg.deuce.transaction.contextClass=org.deuce.transaction.tl2.Context org.deuce.benchmark.Driver -n ${t} -d ${duration} -w ${warmup} #org.deuce.benchmark.intset.Benchmark RBTree -r ${r} -w ${w} -o ${o}")
else
	result=$(echo "${java} -cp ../bin/ Driver -n ${t} -d ${duration} -w ${warmup} SetBenchmark ${b} -r ${r} -w ${w} -o ${o}")
fi

throughput=`expr $throughput + $(${result} | egrep -e 'Nb iterations        = [^ ]*' -o | cut -d = -f 2)`
done

throughput=`expr $throughput \* $o / 5`
aborts=`expr $aborts / 5`

echo "throughput: " $throughput

echo "Nb Aborts: " $aborts
echo $t " " $throughput " " $aborts >> $log

done
done
done
done
done


#============================================================================

for o in 5; do
#100% writes means 50% successful add/remove and 50% unsuccessful add/remove
#w=100
for w in 10 50 80; do

# i will be r/2 as we initially insert half of the items
#for r in 2048 8192 16384 32768 65536 204800; do
for r in 2048 20480 204800; do

for b in OOTBTree BOOTBTree STM CFTree PTBTree; do
:>logs/intset-${b}-i${i}-w${w}-o${o}-r${r}.log
for t in 1 2 4 8 16 32 48 60; do

throughput=0
aborts=0

for tr in 1 2 3 4 5; do

echo $b " t= " $t " w= " $w " o= " $o " i= " $i " r= " $r " (Trial number " $tr ")"

log=logs/intset-${b}-i${i}-w${w}-o${o}-r${r}.log

if [ "$b" = "STM" ]; then
	result=$(echo "${java} -javaagent:Deuce/bin/deuceAgent.jar -cp Deuce/bin/deuceTests.jar org.deuce.benchmark.Driver -n ${t} -d ${duration} -w ${warmup} org.deuce.benchmark.intset.Benchmark RBTree -r ${r} -w ${w} -o ${o}")
#elif [ "$b" = "TL2" ]; then
#	result=$(echo "${java} -javaagent:Deuce/bin/deuceAgent.jar -cp Deuce/bin/deuceTests.jar -#Dorg.deuce.transaction.contextClass=org.deuce.transaction.tl2.Context org.deuce.benchmark.Driver -n ${t} -d ${duration} -w ${warmup} #org.deuce.benchmark.intset.Benchmark RBTree -r ${r} -w ${w} -o ${o}")
else
	result=$(echo "${java} -cp ../bin/ Driver -n ${t} -d ${duration} -w ${warmup} SetBenchmark ${b} -r ${r} -w ${w} -o ${o}")
fi

throughput=`expr $throughput + $(${result} | egrep -e 'Nb iterations        = [^ ]*' -o | cut -d = -f 2)`

if [ "$b" = "OOTBTree" ]; then
aborts=`expr $aborts + $(${result} | egrep -e 'TotalAborts=[^ ]*' -o | cut -d = -f 2)`
fi

done

throughput=`expr $throughput \* $o / 5`
aborts=`expr $aborts / 5`

echo "throughput: " $throughput

echo "Nb Aborts: " $aborts
echo $t " " $throughput " " $aborts >> $log

done
done
done
done
done
