#for r in 2048 8192 16384 32768 65536; do
for r in 20480; do
for w in 50; do
for t in 48; do

g=logs/aborts.gp
eps_abort=plots/aborts.eps

echo "set terminal postscript eps enhanced mono dashed lw 1 \"Helvetica\" 30" > ${g}
echo "set pointsize 3"  >> ${g}                              # larger point!
echo "set autoscale" >> ${g}
echo "set boxwidth 1 relative" >> ${g}
echo "set style data histograms" >> ${g}
echo "set style fill solid 1.0" >> ${g}

echo "set key top" >> ${g}
echo "set key left" >> ${g}
echo "set xlabel \"Ops/transaction\"" >> ${g}
echo "set ylabel \"% of Interference\"" >> ${g}
echo "set style fill pattern border" >> ${g}
echo "set yrange [0:100]" >> ${g}
#set arrow 10 from -1,0 to 6,0 nohead

echo "set output \"${eps_abort}\"" >> ${g}

data=logs/aborts.log
echo "plot \"${data}\" using (100*\$2/(\$2+\$3)):xticlabels(1) title \"True\", '' u (100*\$3/(\$2+\$3)) title \"False\"" >> ${g}

gnuplot ${g}
epstopdf ${eps_abort}

done
done
done


#============================================================

#for r in 2048 8192 16384 32768 65536; do
for r in 2048 20480 204800; do
for o in 5; do
for w in 10 50 80; do

g=logs/intset-tree-i${i}-w${w}-o${o}-r${r}.gp
eps_thr=plots/intset-tree-i${i}-w${w}-o${o}-r${r}-thr.eps
eps_abt=plots/intset-tree-i${i}-w${w}-o${o}-r${r}-abt.eps
#png=logs/intset-tree-i${i}-w${w}-o${o}-r${r}.png
#jpg=logs/intset-tree-i${i}-w${w}-o${o}-r${r}.jpg

echo "set terminal postscript eps enhanced mono dashed lw 1 \"Helvetica\" 30" > ${g}
echo "set pointsize 3"  >> ${g}                              # larger point!

#echo "set term jpeg lw 1 \"Helvetica\" 30" > ${g}
#echo "set pointsize 3"  >> ${g}                              # larger point!
#echo "set output \"${jpg}\"" >> ${g}

#echo "set title \"size=${i}, update=${w}%, ops=${o}\"" >> ${g}
echo "set key top" >> ${g}
echo "set key left" >> ${g}
#echo "set xtics 1" >> ${g}
echo "set xlabel \"Number of threads\"" >> ${g}
echo "set ylabel \"1M ops/sec\"" >> ${g}
echo "set output \"${eps_thr}\"" >> ${g}
echo -n "plot " >> ${g}


for b in OOTBTree BOOTBTree PTBTree STM; do
    data=logs/intset-${b}-i${i}-w${w}-o${o}-r${r}.log
    if [ ${b} = "CFTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"CFTree\" with linespoints  lt 1 pt 1" >> ${g}
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "OOTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"TxCF-Tree\" with linespoints  lt 1 pt 2" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "BOOTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"BTxCF-Tree\" with linespoints  lt 1 pt 7" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "PTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"TB\" with linespoints  lt 1 pt 4" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "STM" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"STM\" with linespoints  lt 1 pt 5" >> ${g}    
        echo "" >> ${g}	
    fi
done

gnuplot ${g}
epstopdf ${eps_thr}
#epstopdf ${eps_abt}

done
done
done


#============================================================

for r in 20480; do
for t in 48; do
for w in 50; do

g=logs/intset-tree-i${i}-w${w}-t${t}-r${r}.gp
eps_thr=plots/intset-tree-i${i}-w${w}-t${t}-r${r}-thr.eps

echo "set terminal postscript eps enhanced mono dashed lw 1 \"Helvetica\" 30" > ${g}
echo "set pointsize 3"  >> ${g}                              # larger point!
echo "set key bottom" >> ${g}
echo "set key left" >> ${g}
echo "set xlabel \"Ops/transaction\"" >> ${g}
echo "set ylabel \"1M ops/sec\"" >> ${g}
echo "set output \"${eps_thr}\"" >> ${g}
echo -n "plot " >> ${g}


for b in OOTBTree PTBTree STM; do
    data=logs/intset-${b}-i${i}-w${w}-t${t}-r${r}.log
    if [ ${b} = "CFTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"CFTree\" with linespoints  lt 1 pt 1" >> ${g}
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "OOTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"TxCF-Tree\" with linespoints  lt 1 pt 2" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "BOOTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"Backoff TxCF-Tree\" with linespoints  lt 1 pt 3" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "PTBTree" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"TB\" with linespoints  lt 1 pt 4" >> ${g}    
        echo ", \\" >> ${g}
        echo -n "    " >> ${g}
    elif [ ${b} = "STM" ]; then
        echo -n "\"${data}\" using 1:(\$2/1000000) title \"STM\" with linespoints  lt 1 pt 5" >> ${g}    
        echo "" >> ${g}	
    fi
done

gnuplot ${g}
epstopdf ${eps_thr}
#epstopdf ${eps_abt}

done
done
done
